
my_list <- list(A = c(1, 3, 4, 6),
                i = matrix(1:9, ncol = 3),
                abc = data.frame(x = 1:3))

names(my_list)

my_list$i
my_list[[2]]
my_list[2]

library(tidyverse)

mtcars_nest <- mtcars %>% 
  rownames_to_column(var = "car") %>% 
  group_by(cyl) %>% 
  nest()

str(mtcars_nest)

mtcars_nest$data[[1]]

ggplot(mtcars_nest$data[[1]],
       aes(y = mpg, x = hp)) +
  geom_point()

mt_fit1 <- lm(mpg ~ hp, data = mtcars_nest$data[[1]])

fit_model <- function(df){
  lm(mpg ~ hp, data = df)
}

fit_model(mtcars_nest$data[[1]])

rr <- map(mtcars_nest$data, fit_model)

mtcars_nest %>% 
  mutate(fit = map(data, fit_model)) %>% 
  mutate(coefs = map(fit, tidy)) %>% 
  unnest(coefs, .drop = FALSE)

augment(mt_fit1)
glance(mt_fit1)









